// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

//#include "Car.hpp"
// Pretend file "Car.hpp" contains the following (this is from FAQ 2.17):

#include <string>
using namespace std;

class Car {
public:
  virtual void startEngine();     // Line 1
  virtual bool isRunning() const; // Line 2
  virtual void tuneRadioTo(const string& band, int freq); // Line 3
protected:
  bool isRunning_;                // Line 4
  bool radioOnAM_;
  int  radioFreq_;
};

void f(Car& a)
{
  a.startEngine();  // Changes main()'s x object
  // ...
}

void g(const Car& b) // note the const
{
  b.startEngine();  // Error: can't change an object via a const reference
  // ...
}

main()
{
  Car x;
  f(x);
  g(x);
}
