// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#ifndef CAR_HPP
#define CAR_HPP

class Car {
public:
  Car();             // Declare a constructor
  Car(int initRadioFreq, int horsepower); // Declare another constructor
  // ...
protected:
  bool isRunning_;
  bool radioOnAM_;
  int  radioFreq_;
  int  horsepower_;
};

#endif

void f()
{
  Car a1;  //  The first ctor is used to initialize a1 and *p1
  Car* p1 = new Car();

  Car a2(880, 200);  // The second ctor is used to initialize a2 and *p2
  Car* p2 = new Car(880, 200);

  // ...
}

//#include "Car.hpp"       // Get the Car class

Car::Car()                 // Define a constructor
: isRunning_ (false)
, radioOnAM_ (true)
, radioFreq_ (880)
, horsepower_(150)
{
  // ...
}

Car::Car(int initRadioFreq, int horsepower)
: isRunning_ (false)
, radioOnAM_ (false)
, radioFreq_ (initRadioFreq)
, horsepower_(horsepower)
{
  // ...
}
