// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Engine {
public:
  Engine();
  virtual void start();
};

Engine::Engine()
{
  cout << "Engine constructor\n";
}

void Engine::start()
{
  cout << "Engine::start()\n";
}

class Car {
public:
  Car();
  virtual void startEngine();
protected:
  Engine e_;    // Physically embed an Engine object inside every Car object
};

Car::Car()
: e_ ()    // Initialize the Engine object that's inside the Car object
{
  // Intentionally left blank
}

void Car::startEngine()
{
  e_.start();  // Call the start() member function of the Engine object
}
