// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Engine {
public:
  Engine();
  virtual void start();
};

Engine::Engine()
{
  cout << "Engine constructor\n";
}

void Engine::start()
{
  cout << "Engine::start()\n";
}

class Car {
public:
  Car();
  virtual void startEngine();
  virtual ~Car();
  Car(const Car& c);  // This can be ignored for now; see FAQ [??big-three??]
  Car& operator= (const Car& c);  // This can be ignored for now; see FAQ [??big-three??]
protected:
  Engine* p_;  // Bad form: Try to avoid raw hardware pointers to allocated objects
};
