// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Vehicle {
public:
  virtual void startEngine() = 0;
  virtual ~Vehicle();   // Destructors of ABCs are often virtual
};

Vehicle::~Vehicle()
{
  // Intentionally left blank
}

void f(Vehicle& v)
{
  // ...
  v.startEngine();
  // ...
}

#include <iostream>
using namespace std;

class Car : public Vehicle {
public:
  virtual void startEngine();
};

void Car::startEngine()
{
  cout << "Starting a Car's engine\n";
}

class NuclearSubmarine : public Vehicle {
public:
  virtual void startEngine();
};

void NuclearSubmarine::startEngine()
{
  cout << "Starting a NuclearSubmarine's engine\n";
}

int main()
{
  Car c;
  NuclearSubmarine s;
  f(c);
  f(s);
}

