// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Engine {
public:
  virtual void start();
};

void Engine::start()
{
  cout << "starting Engine\n";
}

class FordTaurus {
public:
  virtual void start();
protected:
  Engine engine_;    // an Engine is part of a FordTaurus
};

void FordTaurus::start()
{
  cout << "starting FordTaurus\n";
  engine_.start();
}

int main()
{
  FordTaurus taurus;
  taurus.start();
}
