// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  virtual int f(int x);
    // REQUIRE: Parameter x must be an odd number
    // PROMISE: Return value will be some even number
  virtual ~Base();
};

Base::~Base()
{ }

class Derived : public Base {
public:
  virtual int f(int x);
    // REQUIRE: Parameter x can be any integer
    // PROMISE: Return value will be 8
};

int Base::f(int x)
{
  if (x % 2 == 0)
    throw "Even!";
  return x + 1;
}

int Derived::f(int x)
{ return 8; }

void sample(Base& b)
{
  // We should only pass odd numbers, since b may actually be a Base...
  int result = b.f(37);

  // We expect result to be even:
  if (result % 2 == 1)
    cerr << "PANIC: call the hotline at 1-800-BAD-BUGS\n";
}

int main()
{
  Base b;     sample(b);
  Derived d;  sample(d);
}
