// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  virtual int f();
    // PROMISE: Return value will be some even number
  virtual ~Base();
};

Base::~Base()
{ }

class Derived : public Base {
public:
  virtual int f();
    // PROMISE: Return value will be 8
};

int Base::f()
{
  // This is allowed to return any even number...
  return 4;
}

int Derived::f()
{
  // This must return 8...
  return 8;
}

void sample(Base& b)
{
  int result = b.f();

  // This is allowed to expect result will be even,
  // but it must not assume that result is 4.
  if (result % 2 == 1)
    cerr << "PANIC: call the hotline at 1-800-BAD-BUGS\n";
}

int main()
{
  Base b;     sample(b);
  Derived d;  sample(d);
}
