// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <string>
using namespace std;

void f(const string& s) throw();  // parameter is received by reference-to-const

void f(const string& s) throw()
{
  #ifdef GENERATE_ERROR
    s += "foo";  // Error: the string cannot be mutated via s
    g(s);        // Error: the const string& cannot be passed as a string&
  #endif
}

void g(string& s) throw();  // parameter is received by reference-to-non-const

void g(string& s) throw()
{
  f(s);        // ok (though it doesn't happen to modify caller's string object)
  s += "foo";  // ok: modifies the caller's string object
}

