// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <stdexcept>
using namespace std;

class Stack {
public:
  Stack() throw();
  void push(int elem) throw(runtime_error);  // throws exception if numElems() is 10
  int  pop()          throw(runtime_error);  // throws exception if numElems() is 0
  int  numElems() const throw();
protected:
  int numElems_;
  int data_[10];
};

int Stack::numElems() const throw()
{
  #ifdef GENERATE_ERROR
    ++numElems_;    //ERROR: can't modify *this
    pop();          //ERROR: pop() isn't a const member function
  #endif
  return numElems_;
}
