// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

namespace A {
  int x = 1;
  int z = 2;
}

namespace B {
  int y = 3;
  int z = 4;
}

void doSomethingWith(int i) throw() { }

void sample() throw()
{
  using namespace A;        // ok: introduces A::x and A::z
  using namespace B;        // ok: introduces B::y and B::z

  doSomethingWith( x );     // ok: unqualified x unambiguously resolves to A::x
  doSomethingWith( y );     // ok: unqualified y unambiguously resolves to B::y

  doSomethingWith( A::z );  // ok: the A:: qualifications makes this unambiguous
  doSomethingWith( B::z );  // ok: the B:: qualifications makes this unambiguous

  #ifdef GENERATE_ERROR
    doSomethingWith( z );   // Error: ambiguous: A::z or B::z?
  #endif
}

main()
{ sample(); }
