// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <string>
#include <iostream>
using namespace std;

class Fred {
public:
  static void   f() throw();
  static string g() throw();
private:
  static string s_;
};

inline string Fred::g() throw()
{ cout << s_; return s_; }  // EVIL: Fred::s_ might not be initialized yet

//#include "Fred.hpp"

string Fred::s_ = "Hello\n";

void Fred::f() throw()
{ cout << s_; }  // GOOD: Fred::s_ is guaranteed to be initialized

//#include "Fred.hpp"

int main()
{ Fred::g(); }

//#include "Fred.hpp"

string x = Fred::g();
