// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class RandomSequence {
public:
  RandomSequence(int initialSeed=1001) throw();
  int operator()() throw();  // The name of the member function is operator()
protected:
  unsigned long current_;
};

RandomSequence::RandomSequence(int initialSeed) throw()
: current_(initialSeed) { }

int RandomSequence::operator()() throw()
{
  current_ = current_ * 22695477UL + 1;
  return int(current_ >> 12) & 0x7fff;
}

int main()
{
  RandomSequence rand;
  for (int i = 0; i < 10; ++i)
    cout << rand() << ' ';
}
