// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"
#include <iostream>
using namespace std;

class Wilma {
public:
  Wilma()  throw();
  void f() throw();
};

inline Wilma::Wilma()  throw() { cout << "Wilma ctor\n"; }
inline void Wilma::f() throw() { cout << "Wilma used\n"; }

class Fred {
public:
  Fred() throw();
protected:
  static Wilma& wilma() throw();  // Same as in the previous FAQ
};

inline Fred::Fred() throw()
{
  cout << "Fred ctor\n";
  wilma().f();                    // Same as in the previous FAQ
}

Fred x;

Wilma& Fred::wilma() throw()
{
  static Wilma w;                 // Used to be static Wilma* p = new Wilma();
  return w;
}
