// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  Fred() throw();
  int publ_;
protected:
  int prot_;
private:
  int priv_;
};

Fred::Fred() throw()
: publ_(1)
, prot_(2)
, priv_(3)
{ }

class Wilma : public Fred {
public:
  void printem() const throw();
};

void Wilma::printem() const throw()
{
  cout << publ_ << '\n';    // ok: derived can access base's public: stuff
  cout << prot_ << '\n';    // ok: derived can access base's protected: stuff

  #ifdef GENERATE_ERROR
    cout << priv_ << '\n';  // Error: derived cannot access base's private: stuff
  #endif
}

int main()
{
  Wilma a;
  a.printem();
}
