// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <string>
using namespace std;

class BTree { /*...*/ };
class Cache { /*...*/ };
class DatabaseCursor;

class Database {
public:
  unsigned numRecords() const throw();
protected:
  friend DatabaseCursor;   // grant access to DatabaseCursor
  BTree btree_;
  Cache cache_;
};

class DatabaseCursor {
public:
  string getCurrentRecord() const throw(out_of_range);
  void   changeCurrentRecord(const string& record) throw(out_of_range);
  void   goToNextRecord() throw(out_of_range);
protected:
  Database* db_;   // The Database to which this cursor object is attached
                   // Pointers into the BTree and/or Cache go here
};
