// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <cstdlib>
using namespace std;

class MyString {
public:
  MyString(const char* s="")  throw();
 ~MyString()                  throw();
  MyString(const MyString& s) throw();
  MyString& operator= (const MyString& s) throw();
  friend ostream& operator<< (ostream& o, const MyString& s) throw();
protected:
  char* s_;
};

MyString::MyString(const char* s) throw()
: s_(strdup(s)) { }

MyString::~MyString() throw()
{ free(s_); }

ostream& operator<< (ostream& o, const MyString& s) throw()
{ return o << s.s_; }

int main()
{
  MyString s = "fred";
  cout << s << "\n";
}
