// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fraction {
public:
  Fraction(int num=0, int denom=1) throw();
  friend Fraction operator* (const Fraction& a, const Fraction& b) throw();
protected:
  int num_, denom_;
};

Fraction::Fraction(int num, int denom) throw()
: num_(num), denom_(denom) { }

Fraction operator* (const Fraction& a, const Fraction& b) throw()
{ return Fraction(a.num_*b.num_, a.denom_*b.denom_); }

int main()
{
  Fraction x = Fraction(3,8);        // "3/8"
  Fraction y = 5*x;
}
