// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <cmath> // To get sin() and cos()
#include <iostream>
using namespace std;

class Point {
public:
  static Point rectangular(float x, float y) throw();    // Rectangular coordinates
  static Point polar(float radius, float angle) throw(); // Polar coordinates
  // These static member functions are the so-called "named constructors"
  // ...
private:
  Point(float x, float y) throw();  // Rectangular coordinates
  float x_, y_;
};

inline Point::Point(float x, float y) throw()
: x_(x), y_(y) { }

inline Point Point::rectangular(float x, float y) throw()
{ return Point(x, y); }

inline Point Point::polar(float radius, float angle) throw()
{ return Point(radius*cos(angle), radius*sin(angle)); }

int main()
{
  Point a = Point::rectangular(5.7, 1.2); // Obviously rectangular
  Point b = Point::polar(5.7, 1.2);       // Obviously polar
}
