// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>      // Must #include this to use "placement new"
using namespace std;

//#include "Fred.hpp" // Declaration of class Fred
// Pretend "Fred.hpp" contains the following:

class Fred {
public:
  Fred() throw();
 ~Fred() throw();
  Fred& operator= (const Fred& x) throw();
  Fred(const Fred& x) throw();
};

void sample() throw()
{
  char memory[sizeof(Fred)];  // Line #1
  void* p = memory;           // Line #2
  Fred* f = new(p) Fred();    // Line #3 (be careful here!)
  // The pointers f and p will be equal
  // ...
}

void sample2() throw()
{
  char memory[sizeof(Fred)];
  void* p = memory;
  Fred* f = new(p) Fred();
  // ...
  f->~Fred();  // Explicitly call the destructor for the placed object
}
