// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  ~Base() throw();  // Should be virtual but is not
};

Base::~Base() throw()
{ cout << "Base destructor\n"; }

void unawareOfDerived(Base* base)
{ delete base; }

class Derived : public Base {
public:
  ~Derived() throw();
};

Derived::~Derived() throw()
{ cout << "Derived destructor\n"; }

int main()
{
  Base* base = new Derived();
  unawareOfDerived(base);
}
