// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

class Fred {
public:
  Fred(int i)        throw();
  Fred(int i, int j) throw();
protected:
  int i_;
  const int j_;
};

Fred::Fred(int i) throw()
: i_(i)
, j_(10)  // Initialize const member j_ with a literal value
{ }

Fred::Fred(int i, int j) throw()
: i_(i)
, j_(j)   // Initialize const member j_ with a constructor parameter
{ }

int main()
{
  Fred a(5);      //a.j_ will always be 10
  Fred b(5,15);   //b.j_ will always be 15
  Fred c(5,20);   //c.j_ will always be 20
}
