// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
#include <iostream>
#include <stdexcept>
using namespace std;

class Stack {
public:
  Stack(int maxLen=5) throw(bad_alloc, runtime_error);
  Stack(const Stack& s) throw(bad_alloc);
  // ...
};

Stack::Stack(int maxLen) throw(bad_alloc, runtime_error)
{ cout << "Stack: maxLen=" << maxLen << '\n'; }

Stack::Stack(const Stack& s) throw(runtime_error)
{ cout << "Stack: copy ctor\n"; }

int main()
{
  // 'a' will be constructed with maxLen=7:
  Stack a(7);

  // all 4 stacks in 'b' will be constructed without arguments (maxLen=5):
  Stack b[4];

  // c[0] will copy from a, c[1] maxLen=8, c[2] maxLen=7,
  // c[3] will be constructed without arguments (maxLen=5):
  Stack c[4] = { a, Stack(8), 7 };
}
