// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <stdexcept>
using namespace std;

class Matrix {
public:
  double& operator() (unsigned row, unsigned col)
    throw(out_of_range);
  double  operator() (unsigned row, unsigned col) const
    throw(out_of_range);
private:
  enum { rows_ = 100, cols_ = 100 };
  double data_[rows_ * cols_];
};

inline double& Matrix::operator() (unsigned row, unsigned col)
throw(out_of_range)
{
  if (row >= rows_ || col >= cols_)
    throw out_of_range("Matrix::operator()");
  return data_[cols_*row + col];
}

inline double Matrix::operator() (unsigned row, unsigned col) const
throw(out_of_range)
{
  if (row >= rows_ || col >= cols_)
    throw out_of_range("Matrix::operator()");
  return data_[cols_*row + col];
}

int main()
{
  Matrix m;
  m(5,8) = 106.15; // Set element (5,8)
  cout << m(5,8);  // Get element (5,8)
}
