// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Fred {
public:
  Fred(int i=3) throw();
  Fred& operator= (const Fred& x) throw();
  friend int operator== (const Fred& a, const Fred& b) throw();
protected:
  int i_;
};

Fred::Fred(int i) throw()
: i_(i) { }

Fred& Fred::operator= (const Fred& x) throw()
{ i_ = x.i_; return *this; }

int operator== (const Fred& a, const Fred& b) throw()
{ return a.i_ == b.i_; }

int main()
{
  Fred x, y, z;
  x = y = 5;         // Result of y = 5 used as an expression
  if ((z = x) == y)  // Result of z = x used as an expression
    cout << "z (which was assigned from x) is equal to y\n";
}

