// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
using namespace std;

class Wilma { };

class Fred {
public:
  Fred()              throw(bad_alloc);
  Fred(const Fred& f) throw(bad_alloc);
 ~Fred()              throw();
  Fred& operator= (const Fred& f) throw(bad_alloc);
  //...
private:
  Wilma* p_;
};

Fred::Fred()              throw(bad_alloc) : p_(new Wilma())      { }
Fred::Fred(const Fred& f) throw(bad_alloc) : p_(new Wilma(*f.p_)) { }
Fred::~Fred()             throw()          { delete p_; }

Fred& Fred::operator= (const Fred& f) throw(bad_alloc)
{
                   // BAD FORM: forgot to check for self-assignment!
  delete p_;       // BAD FORM: delete the old before allocating the new!
  p_ = new Wilma(*f.p_);
  return *this;
}

void sample(Fred& a, Fred& b) throw(bad_alloc)
{ a = b; }

int main()
{
  Fred x;
  sample(x, x);
}
