// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <new>
using namespace std;

class Wilma { };

class Fred {
public:
  Fred()                          throw(bad_alloc);
  Fred(const Fred& f)             throw(bad_alloc);
 ~Fred()                          throw();
  Fred& operator= (const Fred& f) throw(bad_alloc);
  //...
private:
  Wilma* p_;
};

Fred::Fred()              throw(bad_alloc) : p_(new Wilma()) { }
Fred::Fred(const Fred& f) throw(bad_alloc) : p_(new Wilma(*f.p_)) { }
Fred::~Fred()             throw()          { delete p_; }

Fred& Fred::operator= (const Fred& f) throw(bad_alloc)
{
  if (this == &f)  // check for self-assignment: GOOD FORM!
    return *this;
  Wilma* p2 = new Wilma(*f.p_);
  delete p_;       // allocate the new before deleting the old: GOOD FORM!
  p_ = p2;
  return *this;
}
