// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
#include <stdexcept>
using namespace std;

void fred() throw(runtime_error)
{
  cout << "fred() throwing\n";
  throw runtime_error("thrown from fred()");
}

class X {
public:
  ~X() throw();
};

X::~X() throw()
{
  try {
    fred();
  }
  catch (exception& e) {
    cout << "handling fred()'s exception: " << e.what() << '\n';
  }
}

int main()
{
  try {
    X x;
    cout << "main() throwing\n";
    throw logic_error("thrown from main()");
  }
  catch (exception& e) {
    cout << "handling main()'s exception: " << e.what() << '\n';
  }
}
