// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Printer {
public:
  static const char esc;
  virtual ~Printer() throw();
  virtual void italics(const char* s) throw() = 0;
};

Printer::~Printer() throw()
{ }

class EpsonPrinter : public Printer {
public:
  virtual void italics(const char* s) throw();
};

void EpsonPrinter::italics(const char* s) throw()
{ cout << esc << "i+" << s << esc << "i-"; }

class ProprinterPrinter : public Printer {
public:
  virtual void italics(const char* s) throw();
};

void ProprinterPrinter::italics(const char* s) throw()
{ cout << esc << "[i" << s << esc << "[n"; }

class StarPrinter : public Printer {
public:
  virtual void italics(const char* s) throw();
};

void StarPrinter::italics(const char* s) throw()
{ cout << esc << "x" << s << esc << "y"; }

void printUsingItalics(Printer& p, const char* s) throw()
{ p.italics(s); }
