// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  virtual ~Base()         throw();
  virtual void f(int x)   throw();
  virtual void f(float x) throw();
  virtual void g()        throw();
};

Base::~Base() throw()
  { }
void Base::f(int x) throw()
  { cout << "Base::f(int)\n"; }
void Base::f(float x) throw()
  { cout << "Base::f(float)\n"; }
void Base::g() throw()
  { cout << "Base::g()\n"; }

class Derived : public Base {
public:
  virtual void g() throw();
};

void Derived::g() throw()
  { cout << "Derived::g()\n"; }

int main()
{
  Derived d;
  Base* bp = &d;  // OK: Derived is kind-of Base
  bp->f(42);
  bp->f(3.14f);
  bp->g();
}
