// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Base {
public:
  virtual ~Base()         throw();
  virtual void f(float x) throw();
  virtual void g(float x) throw();
  virtual void h(float x) throw();
};

Base::~Base() throw()
  { }
void Base::f(float x) throw()
  { cout << "Base::f(float)\n"; }
void Base::g(float x) throw()
  { cout << "Base::g(float)\n"; }
void Base::h(float x) throw()
  { cout << "Base::h(float)\n"; }

class Derived : public Base {
public:
  virtual void f(float x) throw();
  virtual void g(int x)   throw();  // Normally this would hide g(float) (bad!)
  using Base::g;                    // but this line un-hides g(float) (good!)
};

void Derived::f(float x) throw()
  { cout << "Derived::f(float)\n"; }
void Derived::g(int x) throw()
  { cout << "Derived::g(int)\n"; }

void sample(Base& b, Derived& d)
{
  b.f(3.14f);
  d.f(3.14f);

  b.g(3.14f);
  d.g(3.14f);  // This is not hidden (good!)

  b.h(3.14f);
  d.h(3.14f);
}

int main()
{
  Derived d;
  sample(d, d);
}
