// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class Member {
public:
  Member() throw();
  Member& operator= (const Member&) throw();
};

Member::Member() throw()
  { cout << "constructing a Member\n"; }
Member& Member::operator= (const Member&) throw()
  { cout << "assigning a Member\n"; return *this; }

class Fred {
public:
  Fred() throw() : member_() { }
  // Fred doesn't have an explicit assignment operator
protected:
  Member member_;
};

int main()
{
  Fred a;
  Fred b;
  a = b;  // Compiler synthesized assigment operator Fred::operator= (const Fred&) called here
}
