// Copyright (C) 1994-98 by Addison-Wesley Publishing Co., Inc.
//
// This code is provided for its instructional value.
// It has been tested with care, but it is not guaranteed
// for any particular purpose.  The publisher and authors
// do not offer any warranties or representations, nor do
// they accept any liabilities with respect to this code.

#include "cpp-faqs.hpp"

#include <iostream>
using namespace std;

class X { };

void mayThrow() throw(int)
  { throw 42; }

class Fred {
public:
  Fred() throw(bad_alloc, int);
 ~Fred() throw();
  Fred(const Fred& f) throw();
  Fred& operator= (const Fred& f) throw();
private:
  X* p_;
};

Fred::Fred() throw(bad_alloc, int)
  : p_(new X()) { mayThrow(); }
Fred::~Fred() throw()
  { cout << "Not reached #1\n"; delete p_; }

int main()
{
  try {
    Fred f;
    cout << "Not reached #2\n";
  }
  catch (int e) {
    cout << "Exception caught: " << e << "\n";
  }
}
